/**********************************************************************
 Copyright (c) 2000, 2002 IBM Corp. and others.
 All rights reserved. This program and the accompanying materials
 are made available under the terms of the Common Public License v1.0
 which accompanies this distribution, and is available at
 http://www.eclipse.org/legal/cpl-v10.html

 Contributors:
 IBM Corporation - Initial implementation
 www.phpeclipse.de
 **********************************************************************/
package net.sourceforge.phpdt.externaltools.actions;

import java.text.MessageFormat;

import net.sourceforge.phpeclipse.externaltools.ExternalToolsPlugin;
import net.sourceforge.phpeclipse.ui.WebUI;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.preference.IPreferenceStore;

public class PHPRestartApacheAction extends PHPStartApacheAction {
	public void run(IAction action) {
		final IPreferenceStore webUIStore = WebUI.getDefault()
		.getPreferenceStore();

		String documentRoot = webUIStore.getString(WebUI.PHP_DOCUMENTROOT_PREF);
		final IPreferenceStore store = ExternalToolsPlugin.getDefault()
				.getPreferenceStore();

		// replace backslash with slash in the DocumentRoot under Windows
		documentRoot = documentRoot.replace('\\', '/');
		String[] arguments = { documentRoot, new Integer(WebUI.getDefault().getHttpdPort()).toString() };
		MessageFormat form = new MessageFormat(store
				.getString(ExternalToolsPlugin.APACHE_RESTART_PREF));
		execute("apache_restart", store
				.getString(ExternalToolsPlugin.APACHE_RUN_PREF), form
				.format(arguments), store
				.getBoolean(ExternalToolsPlugin.APACHE_RESTART_BACKGROUND));
	}
}
