/*
 * Created on 23.11.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package net.sourceforge.phpeclipse.xdebug.php.model;

import java.net.MalformedURLException;
import java.net.URL;

import net.sourceforge.phpeclipse.xdebug.core.PHPDebugUtils;
//import net.sourceforge.phpeclipse.xdebug.core.xdebug.ResponseListener.DebugResponse;
import net.sourceforge.phpeclipse.xdebug.core.xdebug.ResponseListener.XDebugResponse;

import org.eclipse.debug.core.DebugEvent;
import org.eclipse.debug.core.DebugException;
import org.eclipse.debug.core.DebugPlugin;
import org.eclipse.debug.core.IDebugEventSetListener;
import org.eclipse.debug.core.model.IBreakpoint;
import org.eclipse.debug.core.model.IStackFrame;
import org.eclipse.debug.core.model.IThread;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 * @author Axel
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class XDebugThread extends XDebugElement implements IThread, IDebugEventSetListener {
	private IStackFrame[]  fStackFrames;
	
	private IBreakpoint[] fBreakpoints;
	
	/* Whether this thread is stepping */
	private boolean fStepping = false;
	private boolean fTerminated = false;
	
	private int fStepCount = 0;
	private int fCurrentStepCount = 0;
	
	/**
	 * Constructs a new thread for the given target
	 * 
	 * @param target VM
	 */
	public XDebugThread(XDebugTarget target) {
		super(target);
		DebugPlugin.getDefault().addDebugEventListener(this);
		fStackFrames = null;
	}
	
	public void incrementStepCounter() {
		fStepCount++;
	}
	
	public IStackFrame[] getStackFrames() throws DebugException {
		IStackFrame[] newStackFrames = null;
		
		if (isSuspended()) {	
			if (fStepCount > fCurrentStepCount) {
				//newStackFrames = ((XDebugTarget) getDebugTarget()).getStackFrames();
				
				XDebugResponse dr = ((XDebugTarget) getDebugTarget()).getStackFrames();
				newStackFrames = _getStackFrames(dr);

				for (int i = 0; i < newStackFrames.length; i++) {
					((XDebugStackFrame)newStackFrames[i]).getVariables();
				}
				
				if (fStackFrames != null) {
					if (newStackFrames.length >= fStackFrames.length) {
						int delta = newStackFrames.length - fStackFrames.length + 1;
						
						for (int i = fStackFrames.length - 1; i >= 0; i--) {
							if (((XDebugStackFrame) fStackFrames[i]).equals(((XDebugStackFrame) newStackFrames[newStackFrames.length  - delta]))) {
								int b = 2; b++;
								//((XDebugStackFrame) newStackFrames[newStackFrames.length - delta]).evaluateChange((XDebugStackFrame) fStackFrames[i]);								
							} else if (((XDebugStackFrame) fStackFrames[i]).isSameStackFrame(newStackFrames[newStackFrames.length  - delta])) {
								//((XDebugStackFrame) newStackFrames[newStackFrames.length - delta]).evaluateChange((XDebugStackFrame) fStackFrames[i]);								
							}
							
							delta ++;
						}
					} else {
					}
				}

				fCurrentStepCount++;

				fStackFrames = newStackFrames;
			}
			return fStackFrames;
		} else {
			return new IStackFrame[0];
		}
	}
	
	private IStackFrame[] _getStackFrames(XDebugResponse lastResponse) {
		//IStackFrame[] newStackFrames = null;

	if (lastResponse.isError())
		return new IStackFrame[0];
	Node response = lastResponse.getParentNode();
	NodeList frames = response.getChildNodes();
	IStackFrame[] theFrames = new IStackFrame[frames.getLength()];
	for (int i = 0; i < frames.getLength(); i++) {
		Node stackNode = frames.item(i);
		XDebugStackFrame frame = new XDebugStackFrame(this/*fThread*/, i);
		String level =PHPDebugUtils.getAttributeValue(stackNode,"level");
		if (!"".equals(level))
			frame.setLevel(Integer.parseInt(level));

		frame.setType(PHPDebugUtils.getAttributeValue(stackNode,"type"));
		String fileName=PHPDebugUtils.unescapeString(PHPDebugUtils.getAttributeValue(stackNode,"filename"));
		String lineNo=PHPDebugUtils.getAttributeValue(stackNode,"lineno");

		if (!"".equals(lineNo))
			frame.setLineNumber(Integer.parseInt(lineNo));
		
		frame.setWhere(PHPDebugUtils.getAttributeValue(stackNode,"where"));
		
		try {
			frame.setFullName(new URL(fileName));
		} catch (MalformedURLException e) {
			e.printStackTrace();
		}
	
		frame.incrementStepCounter();
		
		theFrames[i] = frame;
	}
		return /*newStackFrames*/theFrames;
	}
			
	/* (non-Javadoc)
	 * @see org.eclipse.debug.core.model.IThread#hasStackFrames()
	 */
	public boolean hasStackFrames() throws DebugException {
		return isSuspended();
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.debug.core.model.IThread#getPriority()
	 */
	public int getPriority() throws DebugException {
		return 0;
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.debug.core.model.IThread#getTopStackFrame()
	 */
	public IStackFrame getTopStackFrame() throws DebugException {
		IStackFrame[] frames = getStackFrames();
		if (frames.length > 0) {
			return frames[0];
		}
		
		return null;
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.debug.core.model.IThread#getName()
	 */
	public String getName() throws DebugException {
		return "Thread[1]";
	}

	/* (non-Javadoc)
	 * @see org.eclipse.debug.core.model.IThread#getBreakpoints()
	 */
	public IBreakpoint[] getBreakpoints() {
		if (fBreakpoints == null) {
			return new IBreakpoint[0];
		}
		return fBreakpoints;
	}
	
	/**
	 * Sets the breakpoints this thread is suspended at, or <code>null</code>
	 * if none.
	 * 
	 * @param breakpoints the breakpoints this thread is suspended at, or <code>null</code>
	 * if none
	 */
	protected void setBreakpoints(IBreakpoint[] breakpoints) {
		fBreakpoints = breakpoints;
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.debug.core.model.ISuspendResume#canResume()
	 */
	public boolean canResume() {
		return isSuspended();
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.debug.core.model.ISuspendResume#canSuspend()
	 */
	public boolean canSuspend() {
		return !isTerminated() && !isSuspended();
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.debug.core.model.ISuspendResume#isSuspended()
	 */
	public boolean isSuspended() {
		return fTarget.isSuspended();
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.debug.core.model.ISuspendResume#resume()
	 */
	public void resume() throws DebugException {
		fBreakpoints=null;
		fTarget.resume();
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.debug.core.model.ISuspendResume#suspend()
	 */
	public void suspend() throws DebugException {
		fTarget.suspend();
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.debug.core.model.IStep#canStepInto()
	 */
	public boolean canStepInto() {
		return isSuspended();
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.debug.core.model.IStep#canStepOver()
	 */
	public boolean canStepOver() {
		return isSuspended();
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.debug.core.model.IStep#canStepReturn()
	 */
	public boolean canStepReturn() {
		if (fStackFrames != null) {
			return (fStackFrames.length > 1);
		} else {
			return false;
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.debug.core.model.IStep#isStepping()
	 */
	public boolean isStepping() {
		return fStepping;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.debug.core.model.IStep#stepInto()
	 */
	public void stepInto() throws DebugException {
		fBreakpoints=null;
		fTarget.step_into();
	}

	/* (non-Javadoc)
	 * @see org.eclipse.debug.core.model.IStep#stepOver()
	 */
	public void stepOver() throws DebugException {
		fBreakpoints=null;
		fTarget.step_over();
	}

	/* (non-Javadoc)
	 * @see org.eclipse.debug.core.model.IStep#stepReturn()
	 */
	public void stepReturn() throws DebugException {
		fBreakpoints=null;
		fTarget.step_out();
	}

	/* (non-Javadoc)
	 * @see org.eclipse.debug.core.model.ITerminate#canTerminate()
	 */
	public boolean canTerminate() {
		return !isTerminated();
	}

	/* (non-Javadoc)
	 * @see org.eclipse.debug.core.model.ITerminate#isTerminated()
	 */
	public boolean isTerminated() {
		return fTerminated;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.debug.core.model.ITerminate#terminate()
	 */
	public void terminate() throws DebugException {
		fTarget.getDebugConnection().stop();
		fTerminated = true;
	}
	
	public void terminated() throws DebugException {
		fTerminated = true;
	}

	/**
	 * Sets whether this thread is stepping
	 * 
	 * @param stepping whether stepping
	 */
	protected void setStepping(boolean stepping) {
		fStepping = stepping;
	}

	public void handleDebugEvents(DebugEvent[] events) {
		DebugEvent de = events[0];
		System.out.println(de.toString());	
	}

	public void removeEventListeners() {
		DebugPlugin.getDefault().removeDebugEventListener(this);
	}
}