/*******************************************************************************
 * Copyright (c) 2000, 2003 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/cpl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package net.sourceforge.phpdt.internal.ui.viewsupport;

import org.eclipse.core.resources.IResource;

/**
 * Can be added to a ProblemMarkerManager to get notified about problem marker
 * changes. Used to update error ticks.
 */
public interface IProblemChangedListener {

	/**
	 * Called when problems changed. This call is posted in an aynch exec,
	 * therefore passed resources must not exist.
	 * 
	 * @param changedElements
	 *            A set with elements of type <code>IResource</code> that
	 *            describe the resources that had an problem change.
	 * @param isMarkerChange
	 *            If set to <code>true</code>, the change was a marker
	 *            change, if <code>false</code>, the change came from an
	 *            annotation model modification.
	 */
	void problemsChanged(IResource[] changedResources, boolean isMarkerChange);

}
